/*
 * @(#)Address.java
 *
 * Copyright (C) 2005 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

public class Address {
	public String id;
	public String fname;
	public String lname;
	public String mname;
	public String email;
	public String homeCountry;
	public String homeRegion;
	public String homeCity;
	public String homeIndex;
	public String homeStreet;
	public String homePhone;
	public String mobilePhone;
	
	public static final int ADDR_FROM = 0;
	public static final int ADDR_TO = 1;	
	public static final int ADDR_CC = 2;	
	public static final int ADDR_BCC = 3;	
	
	public Address() {
	}

}
