/*
 * @(#)ContentPane.java
 *
 * Copyright (C) 2006 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

import java.awt.Component;
import java.awt.Dimension;

public interface ContentPane {

	public Component getComponent();

	public void setContentType(String contentType);

	public void setText(String text);

	public void setCaretPosition(int pos);
	
	public String getContentType();
	
	public void setSize(Dimension size);
	
	public boolean needAwt();

	public boolean needSwing();	
}
