/*
 * @(#)MfAwtMenuBar.java
 *
 * Copyright (C) 2008 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */


package olivamail.gui;

import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;

public class MfAwtMenuBar implements IMfMenuBar {
	private Menu jMenu1 = null;

	private MenuItem jMenuItem3 = null;

	private MenuItem jMenuItem4 = null;
	
	private MenuItem miOpenReplied = null;

	private MenuItem jMenuItem5 = null;

	private Menu jMenu2 = null;

	private MenuItem jMenuItem6 = null;

	private MenuItem jMenuItem7 = null;

	private MenuItem jMenuItem8 = null;
	
	private MenuItem miFwdInPlace = null;

	private Menu jMenu3 = null;
	
	private Menu menuFwd = null;

	private MenuItem jMenuItem10 = null;

	private Menu jMenu4 = null;

	private MenuItem jMenuItem9 = null;

	private Menu jMenuNavigation = null;

	private MenuItem jMenuItem11 = null;

	private MenuItem jMenuItem12 = null;	

	private MenuItem jMenuItem13 = null;

	private MenuItem jMenuItem14 = null;

	private MenuItem jMenuItem15 = null;

	private MenuItem jMenuItem16 = null;

	private MenuItem jMenuItem17 = null;
	
	private MenuItem jmiAutoCp = null;

	private Menu jMenuNotify = null;

	private MenuItem jMenuItem18 = null;

	private MenuItem jMenuItem19 = null;
	
	private MenuItem jMenuItem20 = null;
	
	private MenuItem miShowPics = null;
	
	private MessageFrame mf = null;

	private MenuBar menuBar1 = null;	
	
	public MfAwtMenuBar(MessageFrame mf) {
		this.mf = mf;
	}	
		
	/**
	 * This method initializes jMenuItem20	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem20() {
		if (jMenuItem20 == null) {
			jMenuItem20 = new MenuItem();
			jMenuItem20.setLabel(Strings.getString("menuSaveAllAtt"));
			jMenuItem20.setFont(Context.getMenuFont());
			jMenuItem20.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem20_actionPerformed(e);
				}
			});
		}
		return jMenuItem20;
	}
	
	/**
	 * This method initializes jMenuItem19	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem19() {
		if (jMenuItem19 == null) {
			jMenuItem19 = new MenuItem();
			jMenuItem19.setLabel(Strings.getString("MessageFrame.miRNSendInter"));
			jMenuItem19.setFont(Context.getMenuFont());
			jMenuItem19.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem19_actionPerformed(e);
				}
			});
		}
		return jMenuItem19;
	}

	/**
	 * This method initializes jMenuItem18	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem18() {
		if (jMenuItem18 == null) {
			jMenuItem18 = new MenuItem();
			jMenuItem18.setLabel(Strings.getString("MessageFrame.miRNSend"));
			jMenuItem18.setFont(Context.getMenuFont());			
			jMenuItem18.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					mf.jMenuItem18_actionPerformed(e);
				}
			});
		}
		return jMenuItem18;
	}
	
	/**
	 * This method initializes jMenuNotify	
	 * 	
	 * @return java.awt.Menu	
	 */    
	private Menu getMenuNotify() {
		if (jMenuNotify == null) {
			jMenuNotify = new Menu();
			jMenuNotify.setLabel(Strings.getString("MessageFrame.miReadNotific"));
			jMenuNotify.setFont(Context.getMenuFont());
			jMenuNotify.add(getMenuItem18());
			if(!Strings.getLanguage().equalsIgnoreCase("en"))
				jMenuNotify.add(getMenuItem19());
		}
		return jMenuNotify;
	}

	/**
	 * This method initializes jmiAutoCp	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getJmiAutoCp() {
		if (jmiAutoCp == null) {
			jmiAutoCp = new MenuItem();
			jmiAutoCp.setLabel(Strings.getString("cpAuto"));
			jmiAutoCp.setFont(Context.getMenuFont());			
			jmiAutoCp.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					miCharset_actionPerformed(e);
				}
			});
		}
		return jmiAutoCp;
	}

	/**
	 * This method initializes jMenuItem17	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem17() {
		if (jMenuItem17 == null) {
			jMenuItem17 = new MenuItem();
			jMenuItem17.setLabel(Strings.getString("MessageFrame.currMenuItem"));
			jMenuItem17.setFont(Context.getMenuFont());			
			jMenuItem17.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem17_actionPerformed(e);
				}
			});
		}
		return jMenuItem17;
	}

	/**
	 * This method initializes jMenuItem16	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem16() {
		if (jMenuItem16 == null) {
			jMenuItem16 = new MenuItem();
			jMenuItem16.setLabel(Strings.getString("MessageFrame.menuMove"));
			jMenuItem16.setFont(Context.getMenuFont());			
			jMenuItem16.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					Context.mainFrame.callMoveMessages(false);
				}
			});
		}
		return jMenuItem16;
	}
	
	/**
	 * This method initializes jMenuItem15	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem15() {
		if (jMenuItem15 == null) {
			jMenuItem15 = new MenuItem();
			jMenuItem15.setLabel(Strings.getString("MessageFrame.menuLast"));
			jMenuItem15.setFont(Context.getMenuFont());			
			jMenuItem15.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem15_actionPerformed(e);
				}
			});
		}
		return jMenuItem15;
	}	

	/**
	 * This method initializes jMenuItem14	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem14() {
		if (jMenuItem14 == null) {
			jMenuItem14 = new MenuItem();
			jMenuItem14.setLabel(Strings.getString("MessageFrame.menuFirst"));
			jMenuItem14.setFont(Context.getMenuFont());			
			jMenuItem14.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem14_actionPerformed(e);
				}
			});
		}
		return jMenuItem14;
	}

	/**
	 * This method initializes jMenuItem13	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem13() {
		if (jMenuItem13 == null) {
			jMenuItem13 = new MenuItem();
			jMenuItem13.setLabel(Strings.getString("MessageFrame.menuDelete"));
			jMenuItem13.setFont(Context.getMenuFont());			
			jMenuItem13.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem13_actionPerformed(e);
				}
			});
		}
		return jMenuItem13;
	}
		
	/**
	 * This method initializes jMenuItem12	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem12() {
		if (jMenuItem12 == null) {
			jMenuItem12 = new MenuItem();
			jMenuItem12.setLabel(Strings.getString("MainFrame.prevMenuItem"));
			jMenuItem12.setFont(Context.getMenuFont());			
			jMenuItem12.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem12_actionPerformed(e);
				}
			});
		}
		return jMenuItem12;
	}	
	
	/**
	 * This method initializes jMenuItem11	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem11() {
		if (jMenuItem11 == null) {
			jMenuItem11 = new MenuItem();
			jMenuItem11.setLabel(Strings.getString("MainFrame.nextMenuItem"));
			jMenuItem11.setFont(Context.getMenuFont());			
			jMenuItem11.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem11_actionPerformed(e);
				}
			});
		}
		return jMenuItem11;
	}

	/**
	 * This method initializes jMenuNavigation	
	 * 	
	 * @return java.awt.Menu	
	 */    
	private Menu getMenuNavigation() {
		if (jMenuNavigation == null) {
			jMenuNavigation = new Menu();
			jMenuNavigation.setLabel(Strings.getString("MainFrame.navigationMenu"));
			jMenuNavigation.setFont(Context.getMenuFont());
			jMenuNavigation.add(getMenuItem11());
			jMenuNavigation.add(getMenuItem12());
			jMenuNavigation.add(getMenuItem17());
			jMenuNavigation.addSeparator();
			jMenuNavigation.add(getMenuItem14());
			jMenuNavigation.add(getMenuItem15());
		}
		return jMenuNavigation;
	}

	/**
	 * This method initializes jMenuItem9	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem9() {
		if (jMenuItem9 == null) {
			jMenuItem9 = new MenuItem();
			jMenuItem9.setLabel(Strings.getString("menuSaveAs"));
			jMenuItem9.setFont(Context.getMenuFont());			
			jMenuItem9.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem9_actionPerformed(e);
				}
			});
		}
		return jMenuItem9;
	}

	/**
	 * This method initializes jMenuItem10	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem10() {
		if (jMenuItem10 == null) {
			jMenuItem10 = new MenuItem();
			jMenuItem10.setLabel("Text/Html");
			jMenuItem10.setFont(Context.getMenuFont());			
			jMenuItem10.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem10_actionPerformed(e);
				}
			});
		}
		return jMenuItem10;
	}

	/**
	 * This method initializes miShowPics	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMiShowPics() {
		if (miShowPics == null) {
			miShowPics = new MenuItem();
			miShowPics.setLabel(Strings.getString("menuItemShowPics"));
			miShowPics.setFont(Context.getMenuFont());			
			miShowPics.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.miShowPics_actionPerformed(e);
				}
			});
			miShowPics.setEnabled(false);
		}
		return miShowPics;
	}

	/**
	 * This method initializes jMenuItem8	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem8() {
		if (jMenuItem8 == null) {
			jMenuItem8 = new MenuItem();
			jMenuItem8.setLabel(Strings.getString("MessageFrame.menuReply"));
			jMenuItem8.setFont(Context.getMenuFont());			
			jMenuItem8.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem8_actionPerformed(e);
				}
			});
		}
		return jMenuItem8;
	}

	/**
	 * This method initializes jMenu3	
	 * 	
	 * @return java.awt.Menu	
	 */    
	private Menu getMenu3() {
		if (jMenu3 == null) {
			jMenu3 = new Menu();
			jMenu3.setLabel(Strings.getString("menuView"));
			jMenu3.setFont(Context.getMenuFont());			
			jMenu3.add(getCharsetMenu());
			jMenu3.add(getMenuItem10());
			jMenu3.add(getMiShowPics());
		}
		return jMenu3;
	}	

	/**
	 * This method initializes jMenuItem6	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem6() {
		if (jMenuItem6 == null) {
			jMenuItem6 = new MenuItem();
			jMenuItem6.setLabel(Strings.getString("MessageFrame.menuFwdPartly"));
			jMenuItem6.setFont(Context.getMenuFont());			
			jMenuItem6.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem6_actionPerformed(e);
				}
			});
		}
		return jMenuItem6;
	}

	private MenuItem getMiFwdInPlace() {
		if (miFwdInPlace == null) {
			miFwdInPlace = new MenuItem();
			miFwdInPlace.setLabel(Strings.getString("MessageFrame.menuFwdInPlace"));
			miFwdInPlace.setFont(Context.getMenuFont());			
			miFwdInPlace.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jmiFwdInPlace_actionPerformed(e);
				}
			});
		}
		return miFwdInPlace;
	}
		
	/**
	 * This method initializes jMenuItem7	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem7() {
		if (jMenuItem7 == null) {
			jMenuItem7 = new MenuItem();
			jMenuItem7.setLabel(Strings.getString("MessageFrame.menuFwdAtt"));
			jMenuItem7.setFont(Context.getMenuFont());			
			jMenuItem7.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem7_actionPerformed(e);
				}
			});
		}
		return jMenuItem7;
	}

	private Menu getCharsetMenu() {
		if (jMenu4 == null) {
			jMenu4 = new Menu();
			jMenu4.setLabel(Strings.getString("MessageFrame.menuCharset"));
			jMenu4.setFont(Context.getMenuFont());			
			jMenu4.add(getJmiAutoCp());			
			jMenu4.add(getCharsetGroupMenu("Global", Charsets.Global));
			jMenu4.add(getCharsetGroupMenu("WestEuropean", Charsets.WestEuropean));
			jMenu4.add(getCharsetGroupMenu("EastEuropean", Charsets.EastEuropean));
			jMenu4.add(getCharsetGroupMenu("EastAsian", Charsets.EastAsian));
			jMenu4.add(getCharsetGroupMenu("SeAndSwAsian", Charsets.SeAndSwAsian));
		}
		return jMenu4;
	}	

	private Menu getCharsetGroupMenu(String name, String[][] group) {
		Menu result = new Menu();
		result.setLabel(name);
		result.setFont(Context.getMenuFont());
		for(int i = 0; i < group.length; i++) {
			MenuItem mi = new MenuItem(group[i][0]);
			mi.setFont(Context.getMenuFont());
			mi.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					miCharset_actionPerformed(e);
				}
			});
			result.add(mi);
		}		
		return result;
	}

	/**
	 * This method initializes jMenu1	
	 * 	
	 * @return java.awt.Menu	
	 */    
	private Menu getMenu1() {
		if (jMenu1 == null) {
			jMenu1 = new Menu();
			jMenu1.setLabel(Strings.getString("menuFile"));
			jMenu1.setFont(Context.getMenuFont());			
			jMenu1.add(getMenuItem3());
			jMenu1.add(getMenuItem5());
			jMenu1.add(getMenuItem9());
			jMenu1.add(getMenuItem20());
			jMenu1.add(getMiOpenReplied());
			jMenu1.addSeparator();
			jMenu1.add(getMenuItem4());
		}
		return jMenu1;
	}

	/**
	 * This method initializes jMenuItem3	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem3() {
		if (jMenuItem3 == null) {
			jMenuItem3 = new MenuItem();
			jMenuItem3.setLabel(Strings.getString("MessageFrame.menuInBrowser"));
			jMenuItem3.setFont(Context.getMenuFont());			
			jMenuItem3.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem3_actionPerformed(e);
				}
			});
		}
		return jMenuItem3;
	}

	/**
	 * This method initializes jMenuItem4	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem4() {
		if (jMenuItem4 == null) {
			jMenuItem4 = new MenuItem();
			jMenuItem4.setLabel(Strings.getString("menuClose"));
			jMenuItem4.setFont(Context.getMenuFont());
			jMenuItem4.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					mf.disposeFrame();
				}
			});
		}
		return jMenuItem4;
	}

	private MenuItem getMiOpenReplied() {
		if (miOpenReplied == null) {
			miOpenReplied = new MenuItem();
			miOpenReplied.setLabel(Strings.getString("MessageMenu.openReplied"));
			miOpenReplied.setFont(Context.getMenuFont());
			miOpenReplied.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					mf.messageView1.openReplied();
				}
			});
			miOpenReplied.setEnabled(false);
		}
		return miOpenReplied;
	}
	
	
	/**
	 * This method initializes jMenuItem5	
	 * 	
	 * @return java.awt.MenuItem	
	 */    
	private MenuItem getMenuItem5() {
		if (jMenuItem5 == null) {
			jMenuItem5 = new MenuItem();
			jMenuItem5.setLabel(Strings.getString("MessageFrame.menuSource"));
			jMenuItem5.setFont(Context.getMenuFont());			
			jMenuItem5.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem5_actionPerformed(e);
				}
			});
		}
		return jMenuItem5;
	}

	/**
	 * This method initializes jMenu2	
	 * 	
	 * @return java.awt.Menu	
	 */    
	private Menu getMenu2() {
		if (jMenu2 == null) {
			jMenu2 = new Menu();
			jMenu2.setLabel(Strings.getString("MessageFrame.menuAction"));
			jMenu2.setFont(Context.getMenuFont());
			jMenu2.add(getMenuItem8());
			jMenu2.add(getMenuFwd());
			jMenu2.add(getMenuNotify());
			jMenu2.addSeparator();			
			jMenu2.add(getMenuItem13());
			jMenu2.add(getMenuItem16());
		}
		return jMenu2;
	}

	private Menu getMenuFwd() {
		if (menuFwd == null) {
			menuFwd = new Menu();		
			menuFwd.setLabel(Strings.getString("MessageFrame.menuFwd"));
			menuFwd.setFont(Context.getMenuFont());			
			menuFwd.add(getMenuItem6());
			menuFwd.add(getMenuItem7());
			menuFwd.add(getMiFwdInPlace());			
		}
		return menuFwd;
	}	
	
	public void checkShowPics() {		
		if(mf.messageView1.hasPics()) {
			miShowPics.setEnabled(true);
			mf.jbShowPics_setEnabled(true);
		} else {
			miShowPics.setEnabled(false);
			mf.jbShowPics_setEnabled(false);				
		}
	}	
	
	public void hideButtons() {
		jMenuItem3.setEnabled(false);
		jMenuItem5.setEnabled(false);
		jMenuItem8.setEnabled(false);
		jMenuItem6.setEnabled(false);
		jMenuItem7.setEnabled(false);
		jMenu4.setEnabled(false);
		jMenuItem11.setEnabled(false);
		jMenuItem12.setEnabled(false);
		jMenuItem13.setEnabled(false);
		jMenuItem14.setEnabled(false);
		jMenuItem15.setEnabled(false);
		jMenuItem16.setEnabled(false);
		jMenuNotify.setEnabled(false);
		jMenuItem20.setEnabled(false);
		mf.messageView1.hideHeaders();				
	}
		
	/**
	 * This method initializes menuBar1	
	 * 	
	 * @return java.awt.MenuBar	
	 */    
	private MenuBar getMenuBar1() {
		if (menuBar1 == null) {
			menuBar1 = new MenuBar();
			menuBar1.add(getMenu1());
			menuBar1.add(getMenu2());
			menuBar1.add(getMenu3());
			menuBar1.add(getMenuNavigation());
		}
		return menuBar1;
	}
	
	public void jMenuItem10_setEnabled(boolean enabled) {
		jMenuItem10.setEnabled(enabled);
	}

	public void miOpenReplied_setEnabled(boolean enabled) {
		miOpenReplied.setEnabled(enabled);
	}
		
	public void jMenuNavigation_setEnabled(boolean enabled) {
		jMenuNavigation.setEnabled(enabled);
	}
	
	void miCharset_actionPerformed(ActionEvent e) {
		MenuItem mi = (MenuItem) e.getSource();
		String cp = null;
		if (mi != jmiAutoCp)
			cp = Charsets.getCpForName(mi.getLabel());
		mf.messageView1.setCodepage(cp);
	}

	public boolean isAwt() {
		return true;
	}

	public boolean isSwing() {
		return false;
	}
	
	public void bindToMessageFrame() {
		mf.setMenuBar(getMenuBar1());
	}
		
}
