/*
 * @(#)MfAwtMenuBar.java
 *
 * Copyright (C) 2008 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */


package olivamail.gui;

import java.awt.event.ActionEvent;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

public class MfSwingMenuBar implements IMfMenuBar {
	private JMenu jMenu1 = null;

	private JMenuItem jMenuItem3 = null;

	private JMenuItem jMenuItem4 = null;

	private JMenuItem jMenuItem5 = null;

	private JMenu jMenu2 = null;

	private JMenuItem jMenuItem6 = null;

	private JMenuItem jMenuItem7 = null;

	private JMenuItem jMenuItem8 = null;

	private JMenu jMenu3 = null;

	private JMenuItem jMenuItem10 = null;

	private JMenu jMenu4 = null;

	private JMenuItem jMenuItem9 = null;

	private JMenu jMenuNavigation = null;

	private JMenuItem jMenuItem11 = null;

	private JMenuItem jMenuItem12 = null;	

	private JMenuItem jMenuItem13 = null;

	private JMenuItem jMenuItem14 = null;

	private JMenuItem jMenuItem15 = null;

	private JMenuItem jMenuItem16 = null;

	private JMenuItem jMenuItem17 = null;
	
	private JMenuItem jmiAutoCp = null;

	private JMenu jMenuNotify = null;

	private JMenuItem jMenuItem18 = null;

	private JMenuItem jMenuItem19 = null;
	
	private JMenuItem jMenuItem20 = null;
	
	private JMenuItem miShowPics = null;
	
	private MessageFrame mf = null;

	private JMenuBar menuBar1 = null;

	private JMenu jMenuFwd = null;

	private JMenuItem jmiFwdInPlace = null;

	private JMenuItem miOpenReplied = null;	
	
	public MfSwingMenuBar(MessageFrame mf) {
		this.mf = mf;
	}	
			
	/**
	 * This method initializes jMenuItem20	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem20() {
		if (jMenuItem20 == null) {
			jMenuItem20 = new JMenuItem();
			jMenuItem20.setText(Strings.getString("menuSaveAllAtt"));
			//jMenuItem20.setFont(Context.getMenuFont());
			jMenuItem20.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem20_actionPerformed(e);
				}
			});
		}
		return jMenuItem20;
	}
	
	/**
	 * This method initializes jMenuItem19	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem19() {
		if (jMenuItem19 == null) {
			jMenuItem19 = new JMenuItem();
			jMenuItem19.setText(Strings.getString("MessageFrame.miRNSendInter"));
			//jMenuItem19.setFont(Context.getMenuFont());
			jMenuItem19.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem19_actionPerformed(e);
				}
			});
		}
		return jMenuItem19;
	}

	/**
	 * This method initializes jMenuItem18	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem18() {
		if (jMenuItem18 == null) {
			jMenuItem18 = new JMenuItem();
			jMenuItem18.setText(Strings.getString("MessageFrame.miRNSend"));
			//jMenuItem18.setFont(Context.getMenuFont());			
			jMenuItem18.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					mf.jMenuItem18_actionPerformed(e);
				}
			});
		}
		return jMenuItem18;
	}
	
	/**
	 * This method initializes jMenuNotify	
	 * 	
	 * @return java.awt.JMenu	
	 */    
	private JMenu getMenuNotify() {
		if (jMenuNotify == null) {
			jMenuNotify = new JMenu();
			jMenuNotify.setText(Strings.getString("MessageFrame.miReadNotific"));
			//jMenuNotify.setFont(Context.getMenuFont());
			jMenuNotify.add(getMenuItem18());
			if(!Strings.getLanguage().equalsIgnoreCase("en"))
				jMenuNotify.add(getMenuItem19());
		}
		return jMenuNotify;
	}

	/**
	 * This method initializes jmiAutoCp	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getJmiAutoCp() {
		if (jmiAutoCp == null) {
			jmiAutoCp = new JMenuItem();
			jmiAutoCp.setText(Strings.getString("cpAuto"));
			//jmiAutoCp.setFont(Context.getMenuFont());			
			jmiAutoCp.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					miCharset_actionPerformed(e);
				}
			});
		}
		return jmiAutoCp;
	}

	/**
	 * This method initializes jMenuItem17	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem17() {
		if (jMenuItem17 == null) {
			jMenuItem17 = new JMenuItem();
			jMenuItem17.setText(Strings.getString("MessageFrame.currMenuItem"));
			//jMenuItem17.setFont(Context.getMenuFont());			
			jMenuItem17.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem17_actionPerformed(e);
				}
			});
		}
		return jMenuItem17;
	}

	/**
	 * This method initializes jMenuItem16	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem16() {
		if (jMenuItem16 == null) {
			jMenuItem16 = new JMenuItem();
			jMenuItem16.setText(Strings.getString("MessageFrame.menuMove"));
			//jMenuItem16.setFont(Context.getMenuFont());			
			jMenuItem16.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					Context.mainFrame.callMoveMessages(false);
				}
			});
		}
		return jMenuItem16;
	}
	
	/**
	 * This method initializes jMenuItem15	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem15() {
		if (jMenuItem15 == null) {
			jMenuItem15 = new JMenuItem();
			jMenuItem15.setText(Strings.getString("MessageFrame.menuLast"));
			//jMenuItem15.setFont(Context.getMenuFont());			
			jMenuItem15.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem15_actionPerformed(e);
				}
			});
		}
		return jMenuItem15;
	}	

	/**
	 * This method initializes jMenuItem14	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem14() {
		if (jMenuItem14 == null) {
			jMenuItem14 = new JMenuItem();
			jMenuItem14.setText(Strings.getString("MessageFrame.menuFirst"));
			//jMenuItem14.setFont(Context.getMenuFont());			
			jMenuItem14.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem14_actionPerformed(e);
				}
			});
		}
		return jMenuItem14;
	}

	/**
	 * This method initializes jMenuItem13	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem13() {
		if (jMenuItem13 == null) {
			jMenuItem13 = new JMenuItem();
			jMenuItem13.setText(Strings.getString("MessageFrame.menuDelete"));
			//jMenuItem13.setFont(Context.getMenuFont());			
			jMenuItem13.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem13_actionPerformed(e);
				}
			});
		}
		return jMenuItem13;
	}
		
	/**
	 * This method initializes jMenuItem12	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem12() {
		if (jMenuItem12 == null) {
			jMenuItem12 = new JMenuItem();
			jMenuItem12.setText(Strings.getString("MainFrame.prevMenuItem"));
			//jMenuItem12.setFont(Context.getMenuFont());			
			jMenuItem12.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem12_actionPerformed(e);
				}
			});
		}
		return jMenuItem12;
	}	
	
	/**
	 * This method initializes jMenuItem11	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem11() {
		if (jMenuItem11 == null) {
			jMenuItem11 = new JMenuItem();
			jMenuItem11.setText(Strings.getString("MainFrame.nextMenuItem"));
			//jMenuItem11.setFont(Context.getMenuFont());			
			jMenuItem11.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem11_actionPerformed(e);
				}
			});
		}
		return jMenuItem11;
	}

	/**
	 * This method initializes jMenuNavigation	
	 * 	
	 * @return java.awt.JMenu	
	 */    
	private JMenu getMenuNavigation() {
		if (jMenuNavigation == null) {
			jMenuNavigation = new JMenu();
			jMenuNavigation.setText(Strings.getString("MainFrame.navigationMenu"));
			//jMenuNavigation.setFont(Context.getMenuFont());
			jMenuNavigation.add(getMenuItem11());
			jMenuNavigation.add(getMenuItem12());
			jMenuNavigation.add(getMenuItem17());
			jMenuNavigation.addSeparator();
			jMenuNavigation.add(getMenuItem14());
			jMenuNavigation.add(getMenuItem15());
		}
		return jMenuNavigation;
	}

	/**
	 * This method initializes jMenuItem9	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem9() {
		if (jMenuItem9 == null) {
			jMenuItem9 = new JMenuItem();
			jMenuItem9.setText(Strings.getString("menuSaveAs"));
			//jMenuItem9.setFont(Context.getMenuFont());			
			jMenuItem9.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem9_actionPerformed(e);
				}
			});
		}
		return jMenuItem9;
	}

	/**
	 * This method initializes jMenuItem10	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem10() {
		if (jMenuItem10 == null) {
			jMenuItem10 = new JMenuItem();
			jMenuItem10.setText("Text/Html");
			//jMenuItem10.setFont(Context.getMenuFont());			
			jMenuItem10.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem10_actionPerformed(e);
				}
			});
		}
		return jMenuItem10;
	}

	/**
	 * This method initializes miShowPics	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMiShowPics() {
		if (miShowPics == null) {
			miShowPics = new JMenuItem();
			miShowPics.setText(Strings.getString("menuItemShowPics"));
			//miShowPics.setFont(Context.getMenuFont());			
			miShowPics.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.miShowPics_actionPerformed(e);
				}
			});
			miShowPics.setEnabled(false);
		}
		return miShowPics;
	}

	/**
	 * This method initializes jMenuItem8	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem8() {
		if (jMenuItem8 == null) {
			jMenuItem8 = new JMenuItem();
			jMenuItem8.setText(Strings.getString("MessageFrame.menuReply"));
			//jMenuItem8.setFont(Context.getMenuFont());			
			jMenuItem8.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem8_actionPerformed(e);
				}
			});
		}
		return jMenuItem8;
	}

	/**
	 * This method initializes jMenu3	
	 * 	
	 * @return java.awt.JMenu	
	 */    
	private JMenu getMenu3() {
		if (jMenu3 == null) {
			jMenu3 = new JMenu();
			jMenu3.setText(Strings.getString("menuView"));
			//jMenu3.setFont(Context.getMenuFont());			
			jMenu3.add(getCharsetMenu());
			jMenu3.add(getMenuItem10());
			jMenu3.add(getMiShowPics());
		}
		return jMenu3;
	}	

	/**
	 * This method initializes jMenuItem6	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem6() {
		if (jMenuItem6 == null) {
			jMenuItem6 = new JMenuItem();
			jMenuItem6.setText(Strings.getString("MessageFrame.menuFwdPartly"));
			//jMenuItem6.setFont(Context.getMenuFont());			
			jMenuItem6.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem6_actionPerformed(e);
				}
			});
		}
		return jMenuItem6;
	}

	/**
	 * This method initializes jMenuItem7	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem7() {
		if (jMenuItem7 == null) {
			jMenuItem7 = new JMenuItem();
			jMenuItem7.setText(Strings.getString("MessageFrame.menuFwdAtt"));
			//jMenuItem7.setFont(Context.getMenuFont());			
			jMenuItem7.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem7_actionPerformed(e);
				}
			});
		}
		return jMenuItem7;
	}

	private JMenu getCharsetMenu() {
		if (jMenu4 == null) {
			jMenu4 = new JMenu();
			jMenu4.setText(Strings.getString("MessageFrame.menuCharset"));
			//jMenu4.setFont(Context.getMenuFont());			
			jMenu4.add(getJmiAutoCp());			
			jMenu4.add(getCharsetGroupMenu("Global", Charsets.Global));
			jMenu4.add(getCharsetGroupMenu("WestEuropean", Charsets.WestEuropean));
			jMenu4.add(getCharsetGroupMenu("EastEuropean", Charsets.EastEuropean));
			jMenu4.add(getCharsetGroupMenu("EastAsian", Charsets.EastAsian));
			jMenu4.add(getCharsetGroupMenu("SeAndSwAsian", Charsets.SeAndSwAsian));
		}
		return jMenu4;
	}	

	private JMenu getCharsetGroupMenu(String name, String[][] group) {
		JMenu result = new JMenu();
		result.setText(name);
		//result.setFont(Context.getMenuFont());
		for(int i = 0; i < group.length; i++) {
			JMenuItem mi = new JMenuItem(group[i][0]);
			//mi.setFont(Context.getMenuFont());
			mi.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					miCharset_actionPerformed(e);
				}
			});
			result.add(mi);
		}		
		return result;
	}

	/**
	 * This method initializes jMenu1	
	 * 	
	 * @return java.awt.JMenu	
	 */    
	private JMenu getMenu1() {
		if (jMenu1 == null) {
			jMenu1 = new JMenu();
			jMenu1.setText(Strings.getString("menuFile"));
			//jMenu1.setFont(Context.getMenuFont());			
			jMenu1.add(getMenuItem3());
			jMenu1.add(getMenuItem5());
			jMenu1.add(getMenuItem9());
			jMenu1.add(getMenuItem20());			
			jMenu1.add(getMiOpenReplied());
			jMenu1.addSeparator();
			jMenu1.add(getMenuItem4());
		}
		return jMenu1;
	}

	/**
	 * This method initializes jMenuItem3	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem3() {
		if (jMenuItem3 == null) {
			jMenuItem3 = new JMenuItem();
			jMenuItem3.setText(Strings.getString("MessageFrame.menuInBrowser"));
			//jMenuItem3.setFont(Context.getMenuFont());			
			jMenuItem3.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem3_actionPerformed(e);
				}
			});
		}
		return jMenuItem3;
	}

	/**
	 * This method initializes jMenuItem4	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem4() {
		if (jMenuItem4 == null) {
			jMenuItem4 = new JMenuItem();
			jMenuItem4.setText(Strings.getString("menuClose"));
			//jMenuItem4.setFont(Context.getMenuFont());
			jMenuItem4.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					mf.disposeFrame();
				}
			});
		}
		return jMenuItem4;
	}

	/**
	 * This method initializes jMenuItem5	
	 * 	
	 * @return java.awt.JMenuItem	
	 */    
	private JMenuItem getMenuItem5() {
		if (jMenuItem5 == null) {
			jMenuItem5 = new JMenuItem();
			jMenuItem5.setText(Strings.getString("MessageFrame.menuSource"));
			//jMenuItem5.setFont(Context.getMenuFont());			
			jMenuItem5.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jMenuItem5_actionPerformed(e);
				}
			});
		}
		return jMenuItem5;
	}

	/**
	 * This method initializes jMenu2	
	 * 	
	 * @return java.awt.JMenu	
	 */    
	private JMenu getMenu2() {
		if (jMenu2 == null) {
			jMenu2 = new JMenu();
			jMenu2.setText(Strings.getString("MessageFrame.menuAction"));
			//jMenu2.setFont(Context.getMenuFont());
			jMenu2.add(getMenuItem8());
			jMenu2.add(getJMenuFwd());
			jMenu2.add(getMenuNotify());
			jMenu2.addSeparator();			
			jMenu2.add(getMenuItem13());
			jMenu2.add(getMenuItem16());
		}
		return jMenu2;
	}

	public void checkShowPics() {		
		if(mf.messageView1.hasPics()) {
			miShowPics.setEnabled(true);
			mf.jbShowPics_setEnabled(true);
		} else {
			miShowPics.setEnabled(false);
			mf.jbShowPics_setEnabled(false);				
		}
	}	
	
	public void hideButtons() {
		jMenuItem3.setEnabled(false);
		jMenuItem5.setEnabled(false);
		jMenuItem8.setEnabled(false);
		jMenuItem6.setEnabled(false);
		jMenuItem7.setEnabled(false);
		jMenu4.setEnabled(false);
		jMenuItem11.setEnabled(false);
		jMenuItem12.setEnabled(false);
		jMenuItem13.setEnabled(false);
		jMenuItem14.setEnabled(false);
		jMenuItem15.setEnabled(false);
		jMenuItem16.setEnabled(false);
		jMenuNotify.setEnabled(false);
		jMenuItem20.setEnabled(false);
		mf.messageView1.hideHeaders();				
	}
		
	/**
	 * This method initializes menuBar1	
	 * 	
	 * @return java.awt.MenuBar	
	 */    
	private JMenuBar getMenuBar1() {
		if (menuBar1 == null) {
			menuBar1 = new JMenuBar();
			menuBar1.add(getMenu1());
			menuBar1.add(getMenu2());
			menuBar1.add(getMenu3());
			menuBar1.add(getMenuNavigation());
		}
		return menuBar1;
	}
	
	public void jMenuItem10_setEnabled(boolean enabled) {
		jMenuItem10.setEnabled(enabled);
	}
	
	public void jMenuNavigation_setEnabled(boolean enabled) {
		jMenuNavigation.setEnabled(enabled);
	}
	
	void miCharset_actionPerformed(ActionEvent e) {
		JMenuItem mi = (JMenuItem) e.getSource();
		String cp = null;
		if (mi != jmiAutoCp)
			cp = Charsets.getCpForName(mi.getText());
		mf.messageView1.setCodepage(cp);
	}

	public boolean isAwt() {
		return false;
	}

	public boolean isSwing() {
		return true;
	}	
	
	public void bindToMessageFrame() {
		mf.setJMenuBar(getMenuBar1());
	}

	/**
	 * This method initializes jMenuFwd	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private JMenu getJMenuFwd() {
		if (jMenuFwd == null) {
			jMenuFwd = new JMenu();
			jMenuFwd.setText(Strings.getString("MessageFrame.menuFwd"));
			jMenuFwd.add(getMenuItem6());
			jMenuFwd.add(getMenuItem7());
			jMenuFwd.add(getJmiFwdInPlace());
		}
		return jMenuFwd;
	}

	/**
	 * This method initializes jmiFwdInPlace	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getJmiFwdInPlace() {
		if (jmiFwdInPlace == null) {
			jmiFwdInPlace = new JMenuItem();
			jmiFwdInPlace.setText(Strings.getString("MessageFrame.menuFwdInPlace"));
			jmiFwdInPlace.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.jmiFwdInPlace_actionPerformed(e);
				}
			});
		}
		return jmiFwdInPlace;
	}

	/**
	 * This method initializes miOpenReplied	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private JMenuItem getMiOpenReplied() {
		if (miOpenReplied == null) {
			miOpenReplied = new JMenuItem();
			miOpenReplied.setText(Strings.getString("MessageMenu.openReplied"));
			miOpenReplied.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					mf.messageView1.openReplied();
				}
			});
			miOpenReplied.setEnabled(false);
		}
		return miOpenReplied;
	}
		
	public void miOpenReplied_setEnabled(boolean enabled) {
		miOpenReplied.setEnabled(enabled);
	}
		
}
