/*
 * @(#)Settings.java
 *
 * Copyright (C) 2006 Sergey Bredikhin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */

package olivamail.gui;

public class Settings {

	public Settings(String name, int type) {
		this.name = name;
		this.type = type;
	}

	private String name = null;
	
	private int type = -1;
	
	public String getName() {
		return name;
	}
	
	public int getType() {
		return type;
	}
	
	public String toString() {
		return name;
	}
	
	public static final int S_ROOT = 0;	
	
	public static final int S_INCOMING = 1;
	
	public static final int S_STORAGE = 2;	
	
	public static final int S_INTERNAT = 3;
	
	public static final int S_READ= 4;
	
	public static final int PANELS_COUNT = 5;	
}
